//
//  NEXSituation.h
//  NumberEightCompiled
//
//  Created by Oliver Kocsis on 19/06/2018.
//  Copyright © 2018 NumberEight Technologies Ltd. All rights reserved.
//
#pragma once

#import "NESituation.h"
#import "NEXSensorItem.h"

NS_ASSUME_NONNULL_BEGIN

/**
 * Represents the overall situation of the user, comprising a major and minor type.
 *
 * The major type is the high-level situation of the user.
 * The minor type is a more granular situation.
 */
@interface NEXSituation : NEXSensorItem

/**
 * Default constructor.
 */
- (instancetype)init;

/**
 * Default constructor.
 */
+ (instancetype)new;

/**
 * Conversion copy constructor.
 * @param situation NESituation to copy from.
 */
- (instancetype)initWithSituation:(NESituation)situation;

/**
 * Conversion copy constructor.
 * @param situation NESituation to copy from.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithSituation:(NESituation)situation confidence:(double)confidence;

/**
 * @param major Major situation type.
 */
- (instancetype)initWithMajor:(NESituationMajor)major;

/**
 * @param major Major situation type.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithMajor:(NESituationMajor)major confidence:(double)confidence;

/**
 * @param major Major situation type.
 * @param minor Minor situation type.
 */
- (instancetype)initWithMajor:(NESituationMajor)major minor:(NESituationMinor)minor;

/**
 * @param major Major situation type.
 * @param minor Minor situation type.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithMajor:(NESituationMajor)major
                        minor:(NESituationMinor)minor
                   confidence:(double)confidence;

/**
 * Parse a string in serialized form.
 * @param string The serialized string, as generated by serialize()
 *
 * @return `nil` if unserialization failed.
 */
+ (instancetype _Nullable)unserializeWithString:(NSString*)string;

@property(nonatomic, readonly) NESituation value DEPRECATED_ATTRIBUTE;

/**
 * A high-level representation of the user's situation.
 */
@property(nonatomic, readwrite) NESituationMajor major;

/**
 * A granular representation of the user's situation.
 */
@property(nonatomic, readwrite) NESituationMinor minor;

+ (NSString*)stringFromMajor:(NESituationMajor)major;
+ (NSString*)stringFromMinor:(NESituationMinor)minor;

/**
 * @return A hash value representing the state of the Type.
 *          Can be used for checking equality.
 */
@property(nonatomic, readonly) NSUInteger hash;

/**
 * @return The name of the concrete value class extending NEXSensorItem.
 */
@property(nonatomic, readonly) NSString* type;

/**
 * @return A human-readable format of the held data.
 */
@property(nonatomic, readonly) NSString* description;

/**
 * @return A machine-readable format of the held data.  Returns `nil` if @p type is invalid, or if
 * serialization failed.
 */
- (NSString* _Nullable)serialize;

/**
 * Strict equality comparison.
 *
 * @see NESituation_isEqual
 *
 * @param object Value to compare with.
 */
- (BOOL)isEqual:(id _Nullable)object;

/**
 * Convert the Objective-C class to a C-compatible struct.
 */
- (NESituation)c_val;

@end
NS_ASSUME_NONNULL_END
